#include "inland_config.h"
subroutine co2 (co2init, co2conc)
! ---------------------------------------------------------------------
      use inland_ibisctl, only: iyear
      implicit none
!     include 'comveg.h'

! Arguments 
      real co2init, &  ! input atmospheric co2 concentration
           co2conc     ! output " for year iyear   

! calculate co2 concentration for this year
!     if (iyear.lt.1860) then
      co2conc = co2init
!     else

! 1992 IPCC estimates
!       iyr = iyear - 1860 + 1
!       co2conc = (297.12 - 0.26716 * iyr +
!    >                      0.0015368 * iyr**2 +
!    >                      3.451e-5 * iyr**3) * 1.e-6
!
! M. El Maayar: 1996 IPCC estimates
!       iyr = iyear - 1860 + 1
!       co2conc = (303.514 - 0.57881 * iyr +
!    >                      0.00622 * iyr**2 +
!    >                      1.3e-5 * iyr**3) * 1.e-6
!     end if
      return
end subroutine co2
