#include "inland_config.h"
! Inland's Pre allocate phase subroutine

!   This subroutine Allocates variables as they are needed by rd_param
! and readit subroutines.
subroutine inland_prealloc
      use inland_ibisparm, only: npft,nband,nsoilay,ndat,plona,plata,nlonsub, &
                                 nlatsub
      use inland_compft, only: vmax_pft,tauleaf,tauroot,tauwood0,TminL,TminU, &
                               Twarm,GDD
      use inland_comveg, only: specla,aleaf,aroot,awood,rhoveg,tauveg,dleaf,  &
                               dstem, clitrl, clitrm, clitrs, clitll, clitlm, &
                               clitls, clitwl, clitwm, clitws, csoislon,      &
                               csoislop, csoipas, fu, fl
      use inland_comtex ! only: all!
      use inland_combgc, only: cnr
      use inland_comsoi, only: hsoi, sand, clay, wsoi
      use inland_comwork ! only: all!
      use inland_combcs, only: xintopo,xinveg,deltat,xint,clmwet, &
                               clmtrng,clmt,clmprec,clmcld,clmq,clmwind, &
                               xintrng,xinprec,xincld,xinq,xinwet,xinwetmon, &
                               xinprecmon, xintrngmon, xincldmon, xinqmon, &
                               xinwindmon, xintmon,obswet,obstrng,obst,obsprec, &
                               obscld, obsq, obswind,xinwind

      implicit none

!! Variables for rd_param
!==========================
! From compft
      allocate(vmax_pft(npft),tauleaf(npft),tauroot(npft),tauwood0(npft), &
               TminL(npft),TminU(npft),Twarm(npft),GDD(npft))

      vmax_pft(:) = 0.
      tauleaf(:) = 0.
      tauroot(:) = 0.
      tauwood0(:) = 0.
      TminL(:) = 0.
      TminU(:) = 0.
      Twarm(:) = 0.
      GDD(:) = 0.

! From comveg
      allocate(specla(npft),aleaf(npft),aroot(npft),awood(npft), &
               rhoveg(nband,2),tauveg(nband,2))
      allocate(dleaf(2),dstem(2))
      specla(:) = 0.
      aleaf(:)  = 0.
      aroot(:)  = 0.
      awood(:)  = 0.
      rhoveg(:,:) = 0.
      tauveg(:,:) = 0.
      dleaf(:) = 0.
      dstem(:) = 0.

! Allocate variables in comsoi
      allocate(hsoi(nsoilay+1))! FIXME: really needed to allocate nsoilay+1?
      hsoi(:) = 0.

! Allocate variables in comtex
      allocate(texdat(3,ndat),porosdat(ndat),sfielddat(ndat),swiltdat(ndat), &
               bexdat(ndat),suctiondat(ndat),hydrauldat(ndat))
      texdat(:,:) = 0.     
      porosdat(:) = 0.
      sfielddat(:) = 0.
      swiltdat(:) = 0.
      bexdat(:) = 0.
      suctiondat(:) = 0.
      hydrauldat(:) = 0.

! Allocate variables in combgc
      allocate(cnr(10))
      cnr(:) = 0.

!! Variables for readit
!================================
! Allocate variables in comwork
!--------------------------------
! Get comwork's ndim4 size
!    The base values are now on ibisparm module; in the future they will be read
! from the inland.infile called right before inland_prealloc.
      ndim4 = max(nlon,nlat,nband,nsoilay,nsnolay,npft)

!    Now ndim3 is calculated with actual max value (no longer manually chosen),
! taking advantage of dynamic allocation of vectors.
      ndim3=nlon*nlat*ndim4
      allocate(lonindex(lbeg:lend),latindex(lbeg:lend),lonscale(nlon), &
               latscale(nlat),work(ndim2),cdummy(ndim3))
      lonscale(:) = 0.
      latscale(:) = 0.
      work(:) = 0.
      cdummy(:) = 0.

! Allocate variables in combcs
!-------------------------------
!   Please note: lmask have to be allocated into readit as its dimention is
! defined just before lmask is used!
      allocate(xintopo(lbeg:lend),xinveg(lbeg:lend),deltat(lbeg:lend), &
               xint(lbeg:lend,12))
      xintopo(:) = 0.
      xinveg(:) = 0.
      deltat(:) = 0.
      xint(:,:) = 0.

! combcs's readit-specific variables
      allocate(clmwet(lbeg:lend,12),clmtrng(lbeg:lend,12))
      allocate(obswet(lbeg:lend,12),obstrng(lbeg:lend,12))

! combcs's anomaly and readit specific variables
      allocate(clmt(lbeg:lend,12),clmprec(lbeg:lend,12),clmcld(lbeg:lend,12), &
               clmq(lbeg:lend,12),clmwind(lbeg:lend,12))
      clmt(:,:)=0.
      clmprec(:,:)=0.
      clmcld(:,:)=0.
      clmq(:,:)=0.
      clmwind(:,:)=0.

      allocate(obst(lbeg:lend,12),obsprec(lbeg:lend,12),obscld(lbeg:lend,12), &
               obsq(lbeg:lend,12),obswind(lbeg:lend,12))
      obst(:,:)=0.
      obsprec(:,:)=0.
      obscld(:,:)=0.
      obsq(:,:)=0.
      obswind(:,:)=0.

! combcs's weather generator and readit variables
! Please note these are read at readit thus no need to assign zeroes.
      allocate(xinwind(lbeg:lend,12),xintrng(lbeg:lend,12), &
               xinprec(lbeg:lend,12),xincld(lbeg:lend,12),xinq(lbeg:lend,12), &
               xinwet(lbeg:lend,12))

      allocate(xinwindmon(lbeg:lend,12),xintrngmon(lbeg:lend,12), &
               xinprecmon(lbeg:lend,12),xincldmon(lbeg:lend,12),xinqmon(lbeg:lend,12), &
               xinwetmon(lbeg:lend,12),xintmon(lbeg:lend,12))

! Variables in comsoi used for readit subroutine
      allocate(sand(lbeg:lend,nsoilay),clay(lbeg:lend,nsoilay))

! Initial value for this is read on rd_param
      allocate(wsoi(lbeg:lend,nsoilay))

! Variables in comveg identified on optis' parameter set
      allocate(clitrl(lbeg:lend),clitrm(lbeg:lend),clitrs(lbeg:lend), &
               clitll(lbeg:lend),clitlm(lbeg:lend),clitls(lbeg:lend), &
               clitwl(lbeg:lend),clitwm(lbeg:lend),clitws(lbeg:lend), &
               csoislon(lbeg:lend),csoislop(lbeg:lend),csoipas(lbeg:lend), &
               fu(lbeg:lend),fl(lbeg:lend))

! These vars are read from soita.sand and soita.clay; should we still zero it?
      sand(:,:) = 0.
      clay(:,:) = 0.
!      fu(:,:) = 0.
!      fl(:,:) = 0.

! Variables in ibisparm used for readit subroutine.
! Attach (via pointers) nlonsub/nlatsub to plona/plata from ibisparm (compar)
      plona => nlonsub
      plata => nlatsub

! ibiscst part which was moved to ibisparm.
      allocate(garea(lbeg:lend))
      garea(:) = 0.
end subroutine inland_prealloc
