#include "inland_config.h"
! ---------------------------------------------------------------------
subroutine rdmon(istyr, iwest, jnorth)

      use inland_ibispar
      use inland_ibisctl, only: imonth, iyear
      use inland_combcs
      use inland_comwork

      implicit none

      integer i,    & ! loop indice on years after istyr
              istat, &  ! error flag for netcdf
              istyr,  & ! 1st year in data files
              ndim, & !number of dimensions
              ntime,& ! loop indices
              iwest,  & ! 1st lon index for subset
              jnorth    ! 1st lat index for subset! number of dimensions

      character*80 filen
      character*80 :: directory='input/monthly/'
      integer istart(4), icount(4)

      data istart / 1,1,1,1 /, icount / nlon,nlat,1,1 /
      istart(1) = iwest
      istart(2) = jnorth
      icount(1) = nlonsub
      icount(2) = nlatsub

      icount(3) = 1
      icount(4) = 12

      !filen = 'input/wetd.mon.nc'
      aname = 'wetd'
      write(filen,'(A14,A4,A9,I4,A3)')trim(directory),aname,'.monthly.',iyear,'.nc'
      call readvar(filen,aname,'level',istart,icount,cdummy,work(1),   &
                   work(ndim4),work(2*ndim4),work(3*ndim4),istat)
      if (istat.lt.0) then
         write(*,9000)
         print *, 'while reading wetd'
         stop 1
      end if
      do 15 ntime = 1,12
         call arr2vec(cdummy((ntime-1)*nlonsub*nlatsub + 1),obswet(1,ntime))
15    continue

      !filen = 'input/temp.mon.nc'
      aname = 'temp'
      write(filen,'(A14,A4,A9,I4,A3)')trim(directory),aname,'.monthly.',iyear,'.nc'
      call readvar(filen,aname,'level',istart,icount,cdummy,work(1),         &
                   work(ndim4),work(2*ndim4),work(3*ndim4),istat)
      if (istat.lt.0) then
         write(*,9000)
         print *, 'while reading temp'
         stop 1
      end if
      do 20 ntime = 1,12
         call arr2vec(cdummy((ntime-1)*nlonsub*nlatsub + 1),obst(1,ntime))
20    continue

      !filen = 'input/trange.mon.nc'
      aname = 'trange'
      write(filen,'(A14,A6,A9,I4,A3)')trim(directory),aname,'.monthly.',iyear,'.nc'
      call readvar(filen,aname,'level',istart,icount,cdummy,work(1),         &
                   work(ndim4),work(2*ndim4),work(3*ndim4),istat)
      if (istat.lt.0) then
         write(*,9000)
         print *, 'while reading trange'
         stop 1
      end if
      do 25 ntime = 1,12
         call arr2vec(cdummy((ntime-1)*nlonsub*nlatsub + 1),obstrng(1,ntime))
25    continue

      !filen = 'input/prec.mon.nc'
      aname = 'prec'
      write(filen,'(A14,A4,A9,I4,A3)')trim(directory),aname,'.monthly.',iyear,'.nc'
      call readvar(filen,aname,'level',istart,icount,cdummy,work(1),         &
                   work(ndim4),work(2*ndim4),work(3*ndim4),istat)
      if (istat.lt.0) then
         write(*,9000)
         print *, 'while reading prec'
         stop 1
      end if
      do 30 ntime = 1,12
         call arr2vec(cdummy((ntime-1)*nlonsub*nlatsub + 1),obsprec(1,ntime))
30    continue

      !filen = 'input/wspd.mon.nc'
      aname = 'wspd'
      write(filen,'(A14,A4,A9,I4,A3)')trim(directory),aname,'.monthly.',iyear,'.nc'
      call readvar(filen,aname,'level',istart,icount,cdummy,work(1),         &
                   work(ndim4),work(2*ndim4),work(3*ndim4),istat)
      if (istat.lt.0) then
         write(*,9000)
         print *, 'while reading wspd'
         stop 1
      end if
      do 35 ntime = 1,12
         call arr2vec(cdummy((ntime-1)*nlonsub*nlatsub + 1),obswind(1,ntime))
35    continue

      !filen = 'input/cld.mon.nc'
      aname = 'cld'
      write(filen,'(A14,A3,A9,I4,A3)')trim(directory),aname,'.monthly.',iyear,'.nc'
      call readvar(filen,aname,'level',istart,icount,cdummy,work(1),         &
                   work(ndim4),work(2*ndim4),work(3*ndim4),istat)
      if (istat.lt.0) then
         write(*,9000)
         print *, 'while reading cld'
         stop 1
      end if
      do 40 ntime = 1,12
         call arr2vec(cdummy((ntime-1)*nlonsub*nlatsub + 1),obscld(1,ntime))
40    continue

      !filen = 'input/rh.mon.nc'
      aname = 'sphum'
      write(filen,'(A14,A5,A9,I4,A3)')trim(directory),aname,'.monthly.',iyear,'.nc'
      call readvar(filen,aname,'level',istart,icount,cdummy,work(1),         &
                   work(ndim4),work(2*ndim4),work(3*ndim4),istat)
      if (istat.lt.0) then
         write(*,9000)
         print *, 'while reading rh'
         stop
      end if
      do 45 ntime = 1,12
         call arr2vec(cdummy((ntime-1)*nlonsub*nlatsub + 1),obsq(1,ntime))
45    continue

! copy all 5 climatology fields to clm+anom fields for spin up
      ndim = npoi*12
      call scopya(ndim, obst, xintmon)
      call scopya(ndim, obswind, xinwindmon)
      call scopya(ndim, obstrng, xintrngmon)
      call scopya(ndim, obsprec, xinprecmon)
      call scopya(ndim, obscld, xincldmon)
      call scopya(ndim, obsq, xinqmon)
      call scopya(ndim, obswet, xinwetmon)

9000  format (1x,'ERROR in subroutine rdmon')

! return to main program
      return
end subroutine rdmon
